QCAT - Task #1837

User Story # 1897 (Closed): APl endpoints to add new cases
API: Possibility to authenticate through the API

14 Dec 2018 13:55 - Kurt Gerber

Status: Closed Start date: 14 Dec 2018
Priority: High Due date:

Assignee: Kurt Gerber % Done: 0%
Category: Estimated time: 0.00 hour
Target version: Extend API to add cases Spent time: 0.00 hour
Resolution:

Description

e User can authenticate on the API

See specification: Web_Services_Definition

History

#1 - 14 Dec 2018 16:20 - Kurt Gerber

- Status changed from New to Accepted

#2 - 16 Jan 2019 18:22 - Kurt Gerber

- Status changed from Accepted to In Progress

#3 - 16 Jan 2019 18:22 - Kurt Gerber

- Status changed from In Progress to Accepted

#4 - 27 Sep 2019 14:43 - Kurt Gerber

- Description updated

#5 - 27 Sep 2019 15:01 - Kurt Gerber
- Tracker changed from User Story to Task

- Parent task set to #1897

#6 - 10 Oct 2019 16:20 - Kurt Gerber
- Assignee set to Brahadeesh Dheenadayalan_Sivakami

- Priority changed from Normal to High

#7 - 19 Nov 2019 02:16 - Brahadeesh Dheenadayalan_Sivakami

- Status changed from Accepted to Feedback

- Assignee changed from Brahadeesh Dheenadayalan_Sivakami to Kurt Gerber

Hi Kurt,

After discussion with Kevin, here is a proposed authentication mechanism for allowing users to create cases, upload images and edit cases.

This is very non-standard and maybe insecure.

e Use the existing API Token for Primary authentication in all cases.
¢ Create a Secondary authentication table, as follows:

e One to one relationship to the Registered UserID

¢ 3fields --> 'UserID’, '"APPToken' & 'time_stamp'

¢ When a user with the header 'User-Agent: app' sends a request <to create a case, upload images or edit cases>"

e Authenticate with the APl Token to ensure user has access to API.

¢ Check if the Authenticated User has an 'unexpired' APP Token <a time limit is used to designate stale/fresh APP Tokens>
http://redmine.cde.unibe.ch/projects/qcat/wiki/Web_Services_Definition#1-Authentification-endpoint

e No APP Token, Create the token and serve response + new APP Token <initial handshake>

e Unexpired APP Token, accept the request, refresh the token time stamp and serve the response

¢ Expired APP Token, refresh the token and serve the response + new APP Token

¢ Incorrect APP Token, respond as invalid <potential issue here on what to do with works in progress for the user>

Looking ahead to the discussion and feedback.

Thanks,
Guhan

#8 - 03 Dec 2019 15:29 - Kurt Gerber

- Assignee changed from Kurt Gerber to Brahadeesh Dheenadayalan_Sivakami

Could you try to document here, what we have discussed concerning the authentification?

#9 - 14 Dec 2019 00:51 - Brahadeesh Dheenadayalan_Sivakami
- File API_Authentication_proposal_Guhan_2019Dec10.pdf added

- Assignee changed from Brahadeesh Dheenadayalan_Sivakami to Kurt Gerber

Hi Kurt,
Apologies for the delay in getting this out.
Please find attached the description of the proposed solution based on our discussion from 3 weeks back.

Thanks,
Guhan

#10 - 20 Aug 2020 11:56 - Kurt Gerber
- Status changed from Feedback to Closed

Works

Files

API_Authentication_proposal_Guhan_2019Dec10.pdf 172 KB 14 Dec 2019 Brahadeesh Dheenadayalan_Sivakami
